let whitespace = Str.regexp "[ \t,]+"

let elements = ref [||]

let _ = 
  let error_count = ref 0 in
  try while true do
    let line = read_line () in
    let example = Str.split whitespace line in
    let example = List.rev example in
    let example = List.map (fun x -> int_of_string x >= 1 ) example in 
    let label = List.hd example 
    and features = List.rev (List.tl example) in
    let neg_features = List.map (fun x -> not x) features in
    let features = Array.of_list (features @ neg_features) in
    
    if Array.length features <> Array.length !elements 
    then elements := Array.create (Array.length features) 1.;
    
    let pos_sum = ref 0. 
    and neg_sum = ref 0. in
    for i = 0 to Array.length !elements -1 do
      if features.(i) 
      then pos_sum := !pos_sum +. !elements.(i)
      else neg_sum := !neg_sum +. !elements.(i)
    done;
    let result = !pos_sum > !neg_sum in
    
    print_int (if result then 1 else 0);
    print_newline ();
    
    if result <> label
    then 
      incr error_count;
    Array.iteri (fun i feature -> 
      if label <> feature 
      then !elements.(i) <- !elements.(i) *. 0.5) features;
  done
  with
    End_of_file -> 
      print_int !error_count;
      print_string " errors, final concept =\n";
      let last = ref false in
      Array.iteri (fun i x -> 
	print_float x;
	print_char ' ';
	 ) !elements;
      print_newline()
